This was created by checking out qtdeclarative and checking out the
kf5 patches from kde.  For more details of those, see
https://dot.kde.org/2021/04/06/announcing-kdes-qt-5-patch-collection

 from kde:
 git clone https://invent.kde.org/qt/qt/qtdeclarative
 cd qtdeclarative
 git checkout -t origin/5.15
 git format-patch origin/5.15.2..origin/kde/5.15

To update for new patches, git pull and then rerun git format-patch.

Last updated: 2021-01-25

 Following patches commented:
 patch 01 would change the version to 5.15.3
 patches 02, 03, 04 already applied in 5.15.2.

#From 568763928a78b52373932b01be17e040f7c3fa50 Mon Sep 17 00:00:00 2001
#From: Jani Heikkinen <jani.heikkinen@qt.io>
#Date: Tue, 27 Oct 2020 07:48:21 +0200
#Subject: [PATCH 01/41] Bump version
#
#Change-Id: I58fee19a72cda6a19ba168f55caf764c73ffd1c8
#---
# .qmake.conf | 2 +-
# 1 file changed, 1 insertion(+), 1 deletion(-)
#
#diff --git a/.qmake.conf b/.qmake.conf
#index 85b893856b..4e82106546 100644
#--- a/.qmake.conf
#+++ b/.qmake.conf
#@@ -4,4 +4,4 @@ CONFIG += warning_clean
# DEFINES += QT_NO_LINKED_LIST
# DEFINES += QT_NO_JAVA_STYLE_ITERATORS
# 
#-MODULE_VERSION = 5.15.2
#+MODULE_VERSION = 5.15.3
#-- 
#2.33.0
#
#From 5652923d99166e942385eb35b778d26b55ab4b0a Mon Sep 17 00:00:00 2001
#From: Fabian Kosmale <fabian.kosmale@qt.io>
#Date: Tue, 27 Oct 2020 16:54:01 +0100
#Subject: [PATCH 02/41] Inline components: Fix custom parser support
#
#Fixes: QTBUG-85713
#Fixes: QTBUG-87464
#Change-Id: I5c190ad2d02190de90260042cc06e51c1da01c63
#Reviewed-by: Maximilian Goldstein <max.goldstein@qt.io>
#Reviewed-by: Ulf Hermann <ulf.hermann@qt.io>
#(cherry picked from commit 2425cd478138c52694aaa20b7f7eb4a91d97b51c)
#Reviewed-by: Qt Cherry-pick Bot <cherrypick_bot@qt-project.org>
#---
# src/qml/qml/qqmltypecompiler.cpp                    |  6 ++++++
# .../qml/qqmllanguage/data/customParserTypeInIC.qml  | 13 +++++++++++++
# tests/auto/qml/qqmllanguage/tst_qqmllanguage.cpp    | 11 +++++++++++
# 3 files changed, 30 insertions(+)
# create mode 100644 tests/auto/qml/qqmllanguage/data/customParserTypeInIC.qml
#
#diff --git a/src/qml/qml/qqmltypecompiler.cpp b/src/qml/qml/qqmltypecompiler.cpp
#index 058bf8848c..f1a6b3bff2 100644
#--- a/src/qml/qml/qqmltypecompiler.cpp
#+++ b/src/qml/qml/qqmltypecompiler.cpp
#@@ -683,6 +683,9 @@ QQmlCustomParserScriptIndexer::QQmlCustomParserScriptIndexer(QQmlTypeCompiler *t
# void QQmlCustomParserScriptIndexer::annotateBindingsWithScriptStrings()
# {
#     scanObjectRecursively(/*root object*/0);
#+    for (int i = 0; i < qmlObjects.size(); ++i)
#+        if (qmlObjects.at(i)->isInlineComponent)
#+            scanObjectRecursively(i);
# }
# 
# void QQmlCustomParserScriptIndexer::scanObjectRecursively(int objectIndex, bool annotateScriptBindings)
#@@ -1223,6 +1226,9 @@ QQmlDeferredAndCustomParserBindingScanner::QQmlDeferredAndCustomParserBindingSca
# 
# bool QQmlDeferredAndCustomParserBindingScanner::scanObject()
# {
#+    for (int i = 0; i < qmlObjects->size(); ++i)
#+        if (qmlObjects->at(i)->isInlineComponent)
#+            scanObject(i);
#     return scanObject(/*root object*/0);
# }
# 
#diff --git a/tests/auto/qml/qqmllanguage/data/customParserTypeInIC.qml b/tests/auto/qml/qqmllanguage/data/customParserTypeInIC.qml
#new file mode 100644
#index 0000000000..a29d87caa0
#--- /dev/null
#+++ b/tests/auto/qml/qqmllanguage/data/customParserTypeInIC.qml
#@@ -0,0 +1,13 @@
#+import QtQuick 2.15
#+
#+Item {
#+    property int count: myModel.count
#+    component MyModel : ListModel {
#+        ListElement { a: 10 }
#+        ListElement { a: 12 }
#+    }
#+
#+    MyModel {
#+        id: myModel
#+    }
#+}
#diff --git a/tests/auto/qml/qqmllanguage/tst_qqmllanguage.cpp b/tests/auto/qml/qqmllanguage/tst_qqmllanguage.cpp
#index e32fa884a2..8adcbc1837 100644
#--- a/tests/auto/qml/qqmllanguage/tst_qqmllanguage.cpp
#+++ b/tests/auto/qml/qqmllanguage/tst_qqmllanguage.cpp
#@@ -111,6 +111,7 @@ private slots:
#     void bindJSValueToType();
#     void bindTypeToJSValue();
#     void customParserTypes();
#+    void customParserTypeInInlineComponent();
#     void rootAsQmlComponent();
#     void rootItemIsComponent();
#     void inlineQmlComponents();
#@@ -1313,6 +1314,16 @@ void tst_qqmllanguage::customParserTypes()
#     QCOMPARE(object->property("count"), QVariant(2));
# }
# 
#+// Tests that custom pursor types can be instantiated in ICs
#+void tst_qqmllanguage::customParserTypeInInlineComponent()
#+{
#+    QQmlComponent component(&engine, testFileUrl("customParserTypeInIC.qml"));
#+    VERIFY_ERRORS(0);
#+    QScopedPointer<QObject> object(component.create());
#+    QVERIFY(object != nullptr);
#+    QCOMPARE(object->property("count"), 2);
#+}
#+
# // Tests that the root item can be a custom component
# void tst_qqmllanguage::rootAsQmlComponent()
# {
#-- 
#2.33.0
#
#From be3a57263b7e9e03e01fa9dfe637f03ba557950b Mon Sep 17 00:00:00 2001
#From: Maximilian Goldstein <max.goldstein@qt.io>
#Date: Thu, 29 Oct 2020 16:25:23 +0100
#Subject: [PATCH 03/41] Revert "qquickloader: Free memory of loaded components
# after source change"
#
#This reverts commit c5085eb8905f1a3c070f866746110980e84be271.
#It can cause crashes and only fixes an edge case that can't
#be encountered during normal usage.
#
#Change-Id: Ia265f0d6716b59a0f483e5a114b3f3b1a76fe898
#Reviewed-by: Fabian Kosmale <fabian.kosmale@qt.io>
#(cherry picked from commit 0fa6091b1076bc3cc58303ff00d43efdad32b8ad)
#Reviewed-by: Qt Cherry-pick Bot <cherrypick_bot@qt-project.org>
#---
# src/quick/items/qquickloader.cpp | 13 -------------
# 1 file changed, 13 deletions(-)
#
#diff --git a/src/quick/items/qquickloader.cpp b/src/quick/items/qquickloader.cpp
#index 9a8eca871c..8cd63a4236 100644
#--- a/src/quick/items/qquickloader.cpp
#+++ b/src/quick/items/qquickloader.cpp
#@@ -412,19 +412,6 @@ void QQuickLoader::setSource(const QUrl &url)
# void QQuickLoader::setSource(const QUrl &url, bool needsClear)
# {
#     Q_D(QQuickLoader);
#-
#-    // The source has been changed at this point, and we assume that (after
#-    // notifying potential listeners with sourceChanged) that it is now
#-    // safe to actually delete the old component. We have to do this here
#-    // in case the component referenced expensive resources (like uncached
#-    // images), as it might take too long until we return to the event loop.
#-    // We need to explicitly pass QEvent::DeferredDelete to sendPostedEvents,
#-    // else the allowDeferredDelete check in qcoreapplication.cpp will not
#-    // allow the event to pass. This will not affect anything deleted by this
#-    // call, only the previous one. This has to be done as otherwise there
#-    // might be signal handlers that are still in progress.
#-    QCoreApplication::sendPostedEvents(nullptr, QEvent::DeferredDelete);
#-
#     if (d->source == url)
#         return;
# 
#-- 
#2.33.0
#
#From d27e0cc2a41c229c5b4085b2d78c4328a82baecd Mon Sep 17 00:00:00 2001
#From: Antti Kokko <antti.kokko@qt.io>
#Date: Tue, 27 Oct 2020 10:02:12 +0200
#Subject: [PATCH 04/41] Add changes file for Qt 5.15.2
#
#Change-Id: I5bf32a9ba9f5e3f10f23ffe78bceecdfaa23fbc2
#Reviewed-by: Ulf Hermann <ulf.hermann@qt.io>
#Reviewed-by: Shawn Rutledge <shawn.rutledge@qt.io>
#(cherry picked from commit eaa6459984b723cb48b2617fcabab844109c16fa)
#Reviewed-by: Qt Cherry-pick Bot <cherrypick_bot@qt-project.org>
#---
# dist/changes-5.15.2 | 91 +++++++++++++++++++++++++++++++++++++++++++++
# 1 file changed, 91 insertions(+)
# create mode 100644 dist/changes-5.15.2
#
#diff --git a/dist/changes-5.15.2 b/dist/changes-5.15.2
#new file mode 100644
#index 0000000000..39b743a932
#--- /dev/null
#+++ b/dist/changes-5.15.2
#@@ -0,0 +1,91 @@
#+Qt 5.15.2 is a bug-fix release. It maintains both forward and backward
#+compatibility (source and binary) with Qt 5.15.1.
#+
#+For more details, refer to the online documentation included in this
#+distribution. The documentation is also available online:
#+
#+  https://doc.qt.io/qt-5.15/index.html
#+
#+The Qt version 5.15 series is binary compatible with the 5.14.x series.
#+Applications compiled for 5.14 will continue to run with 5.15.
#+
#+Some of the changes listed in this file include issue tracking numbers
#+corresponding to tasks in the Qt Bug Tracker:
#+
#+  https://bugreports.qt.io/
#+
#+Each of these identifiers can be entered in the bug tracker to obtain more
#+information about a particular change.
#+
#+****************************************************************************
#+*                          QtQuick                                         *
#+****************************************************************************
#+
#+ - Animations:
#+   * [QTBUG-82890] alwaysRunToEnd==true does not prevent complex Animations
#+     from stopping anymore.
#+
#+ - Drag and drop:
#+   * [QTBUG-82157] Fixed a crash when changing supportedActions in Drag.
#+
#+ - Item Views:
#+   * [QTBUG-87821] TableView: The sync view is rebuilt even when flicking on
#+     a sync view child now.
#+   * [QTBUG-87680] TableView: The content size is always updated upon model
#+     changes now.
#+   * [QTBUG-74046][QTBUG-85302] ListView: Floating headers and footers
#+     containing mouse-handling items work again when the listview is clipped.
#+
#+ - Layouts:
#+   * [QTBUG-62989] We follow layoutMirroring in Layout margins now.
#+
#+ - Loader:
#+   * [QTBUG-85938] QQuickLoader: The status property changes properly now when
#+     setSource() is called.
#+
#+ - RHI / scene graph:
#+   * [QTBUG-86402] Fixed a crash in QQuickShaderEffect when hiding a parent.
#+   * [QTBUG-86524] We don't leak memory from QQuickView's QOpenGLContextGroup
#+     object anymore.
#+
#+ - Text:
#+   * [QTBUG-61475] You can use different input methods on TextEdit in
#+     QQuickWidget now.
#+
#+****************************************************************************
#+*                          Tooling                                         *
#+****************************************************************************
#+
#+ - [QTBUG-87222] qmlformat: Computed property names work correctly now.
#+ - [QTBUG-86980] qmlformat: for...of loops using array variables are
#+   formatted correctly now.
#+ - [QTBUG-86979] qmlformat: Inline components are formatted correctly now.
#+ - [QTBUG-85317] qmlformat: Template literals are correctly formatted now.
#+
#+****************************************************************************
#+*                          Examples                                        *
#+****************************************************************************
#+
#+ - [QTBUG-87150] The lineedit example uses the correct QML_NAMED_ELEMENT
#+   macro now.
#+ - [QTBUG-85724] The Screen example does not attempt to shadow final
#+   properties with required properties anymore.
#+
#+****************************************************************************
#+*                          QtQml                                           *
#+****************************************************************************
#+
#+ - [QTBUG-87721] qtquick_compiler_add_resources now takes OPTIONS into
#+   account.
#+ - [QTBUG-86989] You can define more than one inline component in a QML file
#+   now.
#+ - [QTBUG-75777] The QML Engine does not deadlock in its destructor anymore
#+   under some conditions when asynchronous loaders are used.
#+
#+****************************************************************************
#+*                        Platform Specific Changes                         *
#+****************************************************************************
#+
#+ - WebOS:
#+   * [QTBUG-83361] You can have activeFocus on multiple windows,
#+     if there is a single window per screen on eglfs.
#-- 
#2.33.0
#
From 4ee1462686dc12eb463f5ba6b378d43a39aed074 Mon Sep 17 00:00:00 2001
From: Fabian Kosmale <fabian.kosmale@qt.io>
Date: Thu, 12 Nov 2020 12:11:29 +0100
Subject: [PATCH 05/41] QQuickView docs: show correct usage of
 setInitialProperties

Change-Id: If63f4c59f18bc0754ce2e68e424f6efd0f512d30
Reviewed-by: Mitch Curtis <mitch.curtis@qt.io>
(cherry picked from commit 54d4f8f526f9c9a1af702b14925e1d34ee8b2134)
Reviewed-by: Qt Cherry-pick Bot <cherrypick_bot@qt-project.org>
---
 src/quick/doc/snippets/qquickview-ex.cpp | 9 +++++++++
 src/quick/items/qquickview.cpp           | 4 ++++
 2 files changed, 13 insertions(+)

diff --git a/src/quick/doc/snippets/qquickview-ex.cpp b/src/quick/doc/snippets/qquickview-ex.cpp
index 32406f8f2f..5f93dfdbe8 100644
--- a/src/quick/doc/snippets/qquickview-ex.cpp
+++ b/src/quick/doc/snippets/qquickview-ex.cpp
@@ -59,3 +59,12 @@ int main(int argc, char *argv[])
     return app.exec();
 }
 //![0]
+
+void makeDocTeamHappyByKeepingExampleCompilable() {
+//![1]
+    QScopedPointer<QQuickView> view { new QQuickView };
+    view->setInitialProperties({"x, 100"}, {"width", 50});
+    view->setSource(QUrl::fromLocalFile("myqmlfile.qml"));
+    view->show();
+//![1]
+}
diff --git a/src/quick/items/qquickview.cpp b/src/quick/items/qquickview.cpp
index 97f6689d8a..b3a5270e9b 100644
--- a/src/quick/items/qquickview.cpp
+++ b/src/quick/items/qquickview.cpp
@@ -240,7 +240,11 @@ void QQuickView::setSource(const QUrl& url)
    Sets the initial properties \a initialProperties with which the QML
    component gets initialized after calling \l QQuickView::setSource().
 
+   \snippet qquickview-ex.cpp 1
+
    \note You can only use this function to initialize top-level properties.
+   \note This function should always be called before setSource, as it has
+   no effect once the component has become \c Ready.
 
    \sa QQmlComponent::createWithInitialProperties()
    \since 5.14
-- 
2.33.0

